#include "image.h"
#include <stdlib.h>
#include <stdio.h>

int getRLE(int *img,int x,int mx,int lim,int *run,int *code)
{
	int px;

	px=x;
	*run=1;
	*code=img[px];
	px++;
	while(px<mx && *code==img[px] && *run<lim ) {
		px++;
		(*run)++;
	}
	return px;
}

int output_raster(FILE *fp,int *img,int mx)
{
	int run,code;
	int x;

	x=0;
	while(x<mx) {
		x=getRLE(img,x,mx,0xff,&run,&code);
		if(run<2) {
		    if(code!=0xff) {
    			fputc(code,fp);
    		}
    		else {
    		    fputc(0xff,fp);
    		    fputc(0x01,fp);
    		    fputc(code,fp);
    		}
		}
		else if(run==2) {
		    if(code!=0xff) {
    			fputc(code,fp);
    			fputc(code,fp);
    		}
    		else {
    		    fputc(0xff,fp);
    		    fputc(0x02,fp);
    		    fputc(code,fp);
    		}
		}
		else {
		    fputc(0xff,fp);
			fputc(run,fp);
			fputc(code,fp);
		}
	}
}

int writePicture(char *fname,ImageData *img)
{
	FILE *fpo;
	int x,y;
	int mx,my;
	Pixel pix;
	int *linebuf;	//Ps̃f[^i[

	mx=img->width;
	my=img->height;

	if((fpo=fopen((char*)fname,"wb"))==NULL) return FALSE;
	
	linebuf=(int*)malloc(sizeof(int)*mx);

	for(y=0;y<my;y++) {
		for(x=0;x<mx;x++) {
			getPixel(img,x,y,&pix);	//摜̉f擾
			linebuf[x]=pix.r;
		}
		output_raster(fpo,linebuf,mx);
	}
	fclose(fpo);

}


main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	res=readBMPfile(av[1],&img);
	if(res<0) {
		printf("摜ǂ߂܂(%d)\n",res);
		return 8;
	}

	writePicture(av[2],img);
	disposeImage(img);
}
