#include "image.h"
#include <stdlib.h>

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	getPicture(av[1],&img);
	writeBMPfile(av[2],img);
}

int getPicture(char *file_name,ImageData **img)
{
	unsigned int sig_read = 0;
	int bit_depth, color_type, interlace_type;
	int i;
	unsigned char *tmprow;
	int mx2;
	int mx,my,mmx,dep,rdep;
	int pat;
	int mode;
	FILE *fp;

	fp=fopen(file_name,"rb");
	if(fp==NULL) {
		printf("File Open Error\n");
		return FALSE;
	}

	// 摜TCY̓ǂݏo
	getImgInfo(&mx,&my,&dep,&pat,fp);

	*img=createImage(mx,my,24);

	decode(fp,*img,pat);

	fclose(fp);
	return 0;
}

int getLong(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,4,fp);
	return (buf[0]<<24) |(buf[1]<<16) | (buf[2]<<8) | buf[3];
}

int getShort(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,2,fp);
	return (buf[0]<<8) | buf[1];
}

unsigned int getC(FILE *fp)
{
	unsigned char buf[4];

	readData(buf,1,fp);
	return (unsigned int)buf[0];
}

int readData(unsigned char *data,int len,FILE *fp)
{
   return fread(data,sizeof(char),len,fp);
}

// -------------------------------------------------------

int getImgInfo(int *mx,int *my,int *dep,int *pat,FILE *fp)
{
	int i;
	unsigned char buf[100],sbuf[256];

	readData(buf,4,fp);
	*mx=getLong(fp);
	*my=getLong(fp);
	*dep=getLong(fp);;
	*pat=getLong(fp);;
}

int decode(FILE *fp,ImageData *img,int pat)
{
	int mx,my;
	int x,y;
	int rx,ry;
	int x1,y1;
	int mmx;
	int shift;
	Pixel rgb,rgb1,rgb2;

	mx=img->width;
	my=img->height;
	for(y=0;y<my;y++) {
		ry=y%2;
		for(x=0;x<mx;x++) {
			rx=x%2;
			if(pat>0 && rx==1 && ry==0) continue;
			if(pat>1 && rx==0 && ry==1) continue;
			if(pat>2 && rx==1 && ry==1) continue;
			rgb.r=getC(fp);
			rgb.g=rgb.r;
			rgb.b=rgb.r;
			setPixel(img,x,y,&rgb);
		}
	}
	if(pat>0) {
		for(y=0;y<my;y+=2) {
			for(x=1;x<mx;x+=2) {
				getPixel(img,x-1,y,&rgb1);
				x1=x+1;
				if(x1>=mx) x1=mx-2;
				getPixel(img,x1,y,&rgb2);
				rgb.r=(rgb1.r+rgb2.r)/2;
				rgb.g=(rgb1.g+rgb2.g)/2;
				rgb.b=(rgb1.b+rgb2.b)/2;
				setPixel(img,x,y,&rgb);
			}
		}
	}
	if(pat>1) {
		for(y=1;y<my;y+=2) {
			for(x=0;x<mx;x+=2) {
				getPixel(img,x,y-1,&rgb1);
				y1=y+1;
				if(y1>=my) y1=my-2;
				getPixel(img,x,y1,&rgb2);
				rgb.r=(rgb1.r+rgb2.r)/2;
				rgb.g=(rgb1.g+rgb2.g)/2;
				rgb.b=(rgb1.b+rgb2.b)/2;
				setPixel(img,x,y,&rgb);
			}
		}
	}
	if(pat>2) {
		for(y=1;y<my;y+=2) {
			for(x=1;x<mx;x+=2) {
				getPixel(img,x-1,y-1,&rgb1);
				x1=x+1;
				if(x1>=mx) x1=mx-2;
				y1=y+1;
				if(y1>=my) y1=my-2;
				getPixel(img,x1,y1,&rgb2);
				rgb.r=(rgb1.r+rgb2.r)/2;
				rgb.g=(rgb1.g+rgb2.g)/2;
				rgb.b=(rgb1.b+rgb2.b)/2;
				setPixel(img,x,y,&rgb);
			}
		}
	}
}
