#include "image.h"
#include <stdlib.h>

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<4) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	res=readBMPfile(av[1],&img);
	if(res<0) {
		printf("摜ǂ߂܂(%d)\n",res);
		return 8;
	}

	writePicture(av[2],img,atoi(av[3]));
	disposeImage(img);
}

int writePicture(char *fname,ImageData *img,int pos)
{
	FILE *fpo;
	int x,y;
	int mx,my,dep;
	Pixel pix;

	mx=img->width;
	my=img->height;
	dep=8;

	if((fpo=fopen((char*)fname,"wb"))==NULL) return FALSE;
	
	outputHeader(fpo,mx,my,dep,pos);
	encode(fpo,img,pos);
	fclose(fpo);

}

int fputLong(long num,FILE *fp)
{
	fputc((num>>24) & 0xff,fp);
	fputc((num>>16) & 0xff,fp);
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

int fputShort(long num,FILE *fp)
{
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

static int bits=0;
static int bdata=0;

int fputBitInit()
{
	bits=0;
	bdata=0;
}

// nrbgo
int fputNBit(int data,int bits,FILE *fp)
{
	int i;
	int b;

	for(i=0;i<bits;i++) {
		b=data>>(bits-i-1);
		fputBit(b&1,fp);
	}
}

// 1rbgo
int fputBit(int bit,FILE *fp)
{
	bdata=(bdata<<1)|bit;
	bits++;
	if(bits>=8) {
		fputc(bdata,fp);
		bits=0;
		bdata=0;
	}
}

// ]rbgo
int flushBit(FILE *fp)
{
	int i;

	for(i=0;i<7;i++) {
		fputBit(0,fp);
	}
}

int outputHeader(FILE *fp,int mx,int my,int dep,int pos)
{
	int i;

	fputc('Y',fp);
	fputc('C',fp);
	fputc('P',fp);
	fputc('O',fp);
	fputLong(mx,fp);
	fputLong(my,fp);
	fputLong(dep,fp);
	fputLong(pos,fp);
}


int encode(FILE *fp,ImageData *img,int pos)
{
	int x,y;
	int yy,cb,cr;
	int R,G,B;
	Pixel rgb;
	int shift;
	int mx,my;

	mx=img->width;
	my=img->height;

	fputBitInit();
	shift=8-pos;
	for(y=0;y<my;y++) {
		for(x=0;x<mx;x++) {
			getPixel(img,x,y,&rgb);
			R=rgb.r;
			G=rgb.g;
			B=rgb.b;
			yy=  77*R+150*G+ 29*B;
			yy/=256;
			cb= -43*R- 85*G+128*B;
			cb/=256;
			cr= 128*R-107*G- 21*B;
			cr/=256;
			cb+=127;
			cr+=127;
			fputNBit(yy,8,fp);
			fputNBit(cb>>shift,pos,fp);
			fputNBit(cr>>shift,pos,fp);
		}
	}
    flushBit(fp);

    return TRUE;
}
