#include "image.h"
#include <stdlib.h>

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	getPicture(av[1],&img);
	writeBMPfile(av[2],img);
}

int getPicture(char *file_name,ImageData **img)
{
	unsigned int sig_read = 0;
	int bit_depth, color_type, interlace_type;
	int i;
	unsigned char *tmprow;
	int mx2;
	int mx,my,mmx,dep,rdep;
	int pos;
	int mode;
	FILE *fp;

	fp=fopen(file_name,"rb");
	if(fp==NULL) {
		printf("File Open Error\n");
		return FALSE;
	}

	// 摜TCY̓ǂݏo
	getImgInfo(&mx,&my,&dep,&pos,fp);

	*img=createImage(mx,my,24);

	decode(fp,*img,pos);

	fclose(fp);
	return 0;
}

int getLong(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,4,fp);
	return (buf[0]<<24) |(buf[1]<<16) | (buf[2]<<8) | buf[3];
}

int getShort(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,2,fp);
	return (buf[0]<<8) | buf[1];
}

unsigned int getC(FILE *fp)
{
	unsigned char buf[4];

	readData(buf,1,fp);
	return (unsigned int)buf[0];
}

static int bits=0;
static int bdata=0;

int fgetBitInit()
{
	bits=0;
	bdata=0;
}

// Nrbg
int fgetNBit(int bits,FILE *fp)
{
	int i;
	int res;

	res=0;
	for(i=0;i<bits;i++) {
		res*=2;
		res+=fgetBit(fp);
	}
	return res;
}

// 1rbg
int fgetBit(FILE *fp)
{
	unsigned char bbuf;
	char buf[4];
	int val;

	if(bits==0) {
		readData(&bbuf,1,fp);
		bdata=bbuf;
	}
	val=(bdata>>7)&1;
	bdata=(bdata<<1) & 0xff;
	bits++;
	if(bits>=8) {
		bits=0;
		bdata=0;
	}
	return val;
}


int readData(unsigned char *data,int len,FILE *fp)
{
   return fread(data,sizeof(char),len,fp);
}

// -------------------------------------------------------

int getImgInfo(int *mx,int *my,int *dep,int *pos,FILE *fp)
{
	int i;
	unsigned char buf[100],sbuf[256];

	readData(buf,4,fp);
	*mx=getLong(fp);
	*my=getLong(fp);
	*dep=getLong(fp);;
	*pos=getLong(fp);;
}

int decode(FILE *fp,ImageData *img,int pos)
{
	int x,y;
	int mmx;
	int shift;
	int yy,cr,cb;
	int R,G,B;
	Pixel rgb;
	int mx,my;

	mx=img->width;
	my=img->height;

	shift=8-pos;
	fgetBitInit();
	for(y=0;y<my;y++) {
		for(x=0;x<mx;x++) {
			yy=fgetNBit(8,fp);
			cb=(fgetNBit(pos,fp)<<shift)-127;
			cr=(fgetNBit(pos,fp)<<shift)-127;
			R=256*yy       +359*cr;
			R/=256;
			G=256*yy- 88*cb-183*cr;
			G/=256;
			B=256*yy+453*cb;
			B/=256;
			if(R<0) R=0;
			if(G<0) G=0;
			if(B<0) B=0;
			rgb.r=R;
			rgb.g=G;
			rgb.b=B;
			setPixel(img,x,y,&rgb);
		}
	}
    return TRUE;
}
