#include "image.h"
#include <stdlib.h>

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	getPicture(av[1],&img);
	writeBMPfile(av[2],img);
}

int getPicture(char *file_name,ImageData **img)
{
	unsigned int sig_read = 0;
	int bit_depth, color_type, interlace_type;
	int i;
	unsigned char *tmprow;
	int mx2;
	int mx,my,mmx,dep,rdep;
	int mode;
	FILE *fp;

	fp=fopen(file_name,"rb");
	if(fp==NULL) {
		printf("File Open Error\n");
		return FALSE;
	}

	// 摜TCY̓ǂݏo
	getImgInfo(&mx,&my,&dep,fp);

	*img=createImage(mx,my,24);

	decode(fp,*img);

	fclose(fp);
	return 0;
}

int getLong(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,4,fp);
	return (buf[0]<<24) |(buf[1]<<16) | (buf[2]<<8) | buf[3];
}

int getShort(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,2,fp);
	return (buf[0]<<8) | buf[1];
}

unsigned int getC(FILE *fp)
{
	unsigned char buf[4];

	readData(buf,1,fp);
	return (unsigned int)buf[0];
}

int readData(unsigned char *data,int len,FILE *fp)
{
   return fread(data,sizeof(char),len,fp);
}

// -------------------------------------------------------

int getImgInfo(int *mx,int *my,int *dep,FILE *fp)
{
	int i;
	unsigned char buf[100],sbuf[256];

	readData(buf,4,fp);
	*mx=getLong(fp);
	*my=getLong(fp);
	*dep=getLong(fp);;
}

int decode(FILE *fp,ImageData *img)
{
	int x,y;
	int mmx;
	int shift;
	int yy,cr,cb;
	int R,G,B;
	Pixel rgb;
	int mx,my;

	mx=img->width;
	my=img->height;

	for(y=0;y<my;y++) {
		for(x=0;x<mx;x++) {
			yy=getC(fp);
			if(x%2==0) {
				cb=(getC(fp))-127;
				cr=(getC(fp))-127;
			}
			R=256*yy       +359*cr;
			R/=256;
			G=256*yy- 88*cb-183*cr;
			G/=256;
			B=256*yy+453*cb;
			B/=256;
			if(R<0) R=0;
			if(G<0) G=0;
			if(B<0) B=0;
			rgb.r=R;
			rgb.g=G;
			rgb.b=B;
			setPixel(img,x,y,&rgb);
		}
	}

    return TRUE;
}
