#include "image.h"
#include <stdlib.h>

#define NNN 8
#define Nketa 3

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	res=readBMPfile(av[1],&img);
	if(res<0) {
		printf("摜ǂ߂܂(%d)\n",res);
		return 8;
	}

	writePicture(av[2],img);
	disposeImage(img);
}

int writePicture(char *fname,ImageData *img)
{
	FILE *fpo;
	int x,y;
	int mx,my,dep;
	Pixel pix;
	unsigned char *lmgbuf;	//Ps̃f[^i[

	mx=img->width;
	my=img->height;
	dep=8;

	if((fpo=fopen((char*)fname,"wb"))==NULL) return FALSE;
	
	lmgbuf=malloc(sizeof(unsigned char)*mx*my);

	//f[^쐬
	for(y=0;y<my;y++) {
		for(x=0;x<mx;x++) {
			getPixel(img,x,y,&pix);	//摜̉f擾
			lmgbuf[x+y*mx]=pix.r;
		}
	}
	outputHeader(fpo,mx,my,dep);
	encode(fpo,lmgbuf,mx,my);
	free(lmgbuf);
	fclose(fpo);

}

int fputLong(long num,FILE *fp)
{
	fputc((num>>24) & 0xff,fp);
	fputc((num>>16) & 0xff,fp);
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

int fputShort(signed short num,FILE *fp)
{
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}


int outputHeader(FILE *fp,int mx,int my,int dep)
{
	int i;

	fputc('H',fp);
	fputc('D',fp);
	fputc('T',fp);
	fputc('N',fp);
	fputLong(mx,fp);
	fputLong(my,fp);
}

static int bits=0;
static int bdata=0;

int fputBitInit()
{
	bits=0;
	bdata=0;
}

// 1rbgo
int fputBit(int bit,FILE *fp)
{
	bdata=(bdata<<1)|bit;
	bits++;
	if(bits>=8) {
		fputc(bdata,fp);
		bits=0;
		bdata=0;
	}
}

// nrbgo
int putBits(FILE *fp,int data,int n)
{
    int i;

    for(i=n-1;i>=0;i--) {
        fputBit((data>>i)&1,fp);
    }
}

// ]rbgo
int flushBit(FILE *fp)
{
	int i;

	for(i=0;i<7;i++) {
		fputBit(0,fp);
	}
}

// bitsrbgnumt@Cɏ
int fputNumber(int num,int bits,FILE *fp)
{
    if(num<0) {
        fputBit(1,fp);
        num= -num;
    }
    else {
        fputBit(0,fp);
    }
    putBits(fp,num,bits);
}

// RGBli[f[^\
typedef struct RGB_COL{
    int r,g,b;
}RGBcolor;

int getColor(int x,int y,unsigned char *data,int mx,int my,RGBcolor *col)
{
    int adr,mmx;

    if(x>=mx) x=mx-1;
    if(y>=my) y=my-1;
    adr=x+y*mx;
    col->r=data[adr];
    col->g=data[adr];
    col->b=data[adr];
}

short adm[NNN][NNN][NNN][NNN];

int encode(FILE *fp,unsigned char *data,int mx,int my)
{
    int x,y,u,v;
    int lx,ly,loopx,loopy;
    int r_re[NNN*NNN];
    int sum;
	RGBcolor col;
	char mbuf[256];

    // A_}[s쐬
    for(v=0;v<NNN;v++) {
        for(u=0;u<NNN;u++) {
            for(y=0;y<NNN;y++) {
                for(x=0;x<NNN;x++) {
                    adm[u][v][x][y]=get_matrix(u,v,x,y);
                }
            }
        }
    }
    loopx=(mx+NNN-1)/NNN;
    loopy=(my+NNN-1)/NNN;
    fputBitInit();
    for(ly=0;ly<loopy;ly++) {
        for(lx=0;lx<loopx;lx++) {
        	// obt@쐬
        	for(y=0;y<=NNN;y++) {
        		for(x=0;x<=NNN;x++) {
        			getColor(lx*NNN+x,ly*NNN+y,data,mx,my,&col);
        			r_re[x+y*NNN]=col.r;
        		}
        	}

            for(v=0;v<NNN;v++) {
                for(u=0;u<NNN;u++) {
                    sum=0;
                    for(y=0;y<NNN;y++) {
                        for(x=0;x<NNN;x++) {
                            if(adm[u][v][x][y]>0) {
                                sum+=(r_re[x+y*NNN]);
                            }
                            else {
                                sum-=(r_re[x+y*NNN]);
                            }
                        }
                    }
                    fputNumber(sum,15,fp);
                }
            }
        }
    }
    flushBit(fp);
}

int get_matrix(int u,int v,int x,int y)
{
	return (func_q(x,y,u,v)%2==0) ? 1 : -1;
}

int func_p(int x,int y,int u,int v)
{
	int i;
	int sum;

	sum=0;
	for(i=0;i<Nketa;i++) {
		sum+=(getNbit(x,i)*getNbit(u,i) | getNbit(y,i)*getNbit(v,i));
	}
	return sum;
}

int func_q(int x,int y,int u,int v)
{
	int i;
	int sum;

	sum=0;
	for(i=0;i<NNN;i++) {
		sum+=(getNbit(x,i)*ggg(u,i)+getNbit(y,i)*ggg(v,i));
	}
	return sum;
}

int ggg(int u,int i)
{
	return getNbit(u,Nketa-i) + getNbit(u,Nketa-i-1);
}

int getNbit(int x,int n)
{
	x>>=n;
	return x&1;
}
