#include "image.h"
#include <stdlib.h>

#define NNN 8
#define Nketa 3

// RGBli[f[^\
typedef struct RGB_COL{	int r,g,b;}RGBcolor;

char mbuf[256];
int readmode;

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	getPicture(av[1],&img);
	writeBMPfile(av[2],img);
}

int getPicture(char *file_name,ImageData **img)
{
	unsigned int sig_read = 0;
	int bit_depth, color_type, interlace_type;
	int i;
	unsigned char *tmprow;
	int mx2;
	int mx,my,mmx,dep,rdep;
	int mode;
	FILE *fp;

	fp=fopen(file_name,"rb");
	if(fp==NULL) {
		printf("File Open Error\n");
		return FALSE;
	}

	// 摜TCY̓ǂݏo
	getImgInfo(&mx,&my,&dep,fp);
	*img=createImage(mx,my,24);

	// 摜f[^GA쐬
	decode(fp,*img);

	fclose(fp);
	return 0;
}



int getLong(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,4,fp);
	return (buf[0]<<24) |(buf[1]<<16) | (buf[2]<<8) | buf[3];
}

int getShort(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,2,fp);
	return (buf[0]<<8) | buf[1];
}

unsigned int getC(FILE *fp)
{
	unsigned char buf[4];

	readData(buf,1,fp);
	return (unsigned int)buf[0];
}

int readData(char *data,int len,FILE *fp)
{
   return fread(data,sizeof(char),len,fp);
}

// -------------------------------------------------------

static int bits=0;
static int bdata=0;

int fgetBitInit()
{
	bits=0;
	bdata=0;
}

// 1rbg
int fgetBit(FILE *fp)
{
	unsigned char bbuf;
	char buf[100];
	int val;

	if(bits==0) {
		readData(&bbuf,1,fp);
		bdata=bbuf;
	}
	val=(bdata>>7)&1;
	bdata=(bdata<<1) & 0xff;
	bits++;
	if(bits>=8) {
		bits=0;
		bdata=0;
	}
	return val;
}

int fgetNumber(int bits,FILE *fp)
{
    int i,res,sn;

    sn=fgetBit(fp);
    if(sn==0) sn=1;
    else sn=-1;
    res=0;
    for(i=0;i<bits;i++) {
        res=res*2;
        res+=fgetBit(fp);
    }
    return res*sn;
}

int getImgInfo(int *mx,int *my,int *dep,FILE *fp)
{
	int i;
	char buf[100],sbuf[256];

	readData(buf,4,fp);
	*mx=getLong(fp);
	*my=getLong(fp);
	*dep=24;
}

short adm[NNN][NNN][NNN][NNN];

int decode(FILE *fp,ImageData *img)
{
    int x,y,u,v;
    int lx,ly,loopx,loopy;
    int r_re[NNN*NNN];
    int sum;
	Pixel col;
	char mbuf[256];
	FILE *fpo;
	int mx,my;

	mx=img->width;
	my=img->height;
    // A_}[s쐬
    for(v=0;v<NNN;v++) {
        for(u=0;u<NNN;u++) {
            for(y=0;y<NNN;y++) {
                for(x=0;x<NNN;x++) {
                    adm[u][v][x][y]=get_matrix(u,v,x,y);
                }
            }
        }
    }
    loopx=(mx+NNN-1)/NNN;
    loopy=(my+NNN-1)/NNN;
	fgetBitInit();
    for(ly=0;ly<loopy;ly++) {
        for(lx=0;lx<loopx;lx++) {

        	for(y=0;y<NNN;y++) {
        		for(x=0;x<NNN;x++) {
        			r_re[x+y*NNN]=fgetNumber(15,fp);
        		}
        	}

            for(v=0;v<NNN;v++) {
                for(u=0;u<NNN;u++) {
                    sum=0;
                    for(y=0;y<NNN;y++) {
                        for(x=0;x<NNN;x++) {
                            if(adm[u][v][x][y]>0) {
                                sum+=(r_re[x+y*NNN]);
                            }
                            else {
                                sum-=(r_re[x+y*NNN]);
                            }
                        }
                    }
                    sum/=(NNN*NNN);
                    col.r=sum;
                    col.g=sum;
                    col.b=sum;
                    setPixel(img,lx*NNN+u,ly*NNN+v,&col);	// 摜ɒlZbg
                }
            }
        }
    }
}

int get_matrix(int u,int v,int x,int y)
{
	return (func_q(x,y,u,v)%2==0) ? 1 : -1;
}

int func_p(int x,int y,int u,int v)
{
	int i;
	int sum;

	sum=0;
	for(i=0;i<Nketa;i++) {
		sum+=(getNbit(x,i)*getNbit(u,i) | getNbit(y,i)*getNbit(v,i));
	}
	return sum;
}

int func_q(int x,int y,int u,int v)
{
	int i;
	int sum;

	sum=0;
	for(i=0;i<NNN;i++) {
		sum+=(getNbit(x,i)*ggg(u,i)+getNbit(y,i)*ggg(v,i));
	}
	return sum;
}

int ggg(int u,int i)
{
	return getNbit(u,Nketa-i) + getNbit(u,Nketa-i-1);
}

int getNbit(int x,int n)
{
	x>>=n;
	return x&1;
}
