#include "image.h"
#include <stdio.h>
#include <limits.h>
#include <math.h>

#define NNN 8
#define Nketa 3

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	getPicture(av[1],&img);
	writeBMPfile(av[2],img);
}

int getPicture(char *file_name,ImageData **img)
{
	unsigned int sig_read = 0;
	int bit_depth, color_type, interlace_type;
	int i;
	unsigned char *tmprow;
	int mx2;
	int mx,my,mmx,dep,rdep;
	int mode;
	FILE *fp;

	fp=fopen(file_name,"rb");
	if(fp==NULL) {
		printf("File Open Error\n");
		return FALSE;
	}

	// 摜TCY̓ǂݏo
	getImgInfo(&mx,&my,&dep,fp);

	*img=createImage(mx,my,24);

	decode(fp,*img);

	fclose(fp);
	return 0;
}

int getLong(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,4,fp);
	return (buf[0]<<24) |(buf[1]<<16) | (buf[2]<<8) | buf[3];
}

int getShort(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,2,fp);
	return (buf[0]<<8) | buf[1];
}

unsigned int getC(FILE *fp)
{
	unsigned char buf[4];

	readData(buf,1,fp);
	return (unsigned int)buf[0];
}

int readData(unsigned char *data,int len,FILE *fp)
{
   return fread(data,sizeof(char),len,fp);
}

// -------------------------------------------------------
static int bits=0;
static int bdata=0;

int fgetBitInit()
{
	bits=0;
	bdata=0;
}

// 1rbg
int fgetBit(FILE *fp)
{
	unsigned char bbuf;
	char buf[100];
	int val;

	if(bits==0) {
		readData(&bbuf,1,fp);
		bdata=bbuf;
	}
	val=(bdata>>7)&1;
	bdata=(bdata<<1) & 0xff;
	bits++;
	if(bits>=8) {
		bits=0;
		bdata=0;
	}
	return val;
}

int fgetNumber(int bits,FILE *fp)
{
    int i,res,sn;

    sn=fgetBit(fp);
    if(sn==0) sn=1;
    else sn=-1;
    res=0;
    for(i=0;i<bits;i++) {
        res=res*2;
        res+=fgetBit(fp);
    }
    return res*sn;
}

int getImgInfo(int *mx,int *my,int *dep,FILE *fp)
{
	int i;
	char buf[100],sbuf[256];

	readData(buf,4,fp);
	*mx=getLong(fp);
	*my=getLong(fp);
	*dep=24;
}

short adm[NNN][NNN][NNN][NNN];

int decode(FILE *fp,ImageData *img)
{
    int x,y,u,v;
    int lx,ly,loopx,loopy;
    double c[NNN*NNN],b[NNN*NNN],a[NNN*NNN];
    int tmp;
	Pixel col;
	int mx,my;

	mx=img->width;
	my=img->height;

    loopx=(mx+NNN-1)/NNN;
    loopy=(my+NNN-1)/NNN;
	fgetBitInit();
	initConst();
    for(ly=0;ly<loopy;ly++) {
        for(lx=0;lx<loopx;lx++) {

        	for(y=0;y<NNN;y++) {
        		for(x=0;x<NNN;x++) {
        			c[x+y*NNN]=(double)fgetNumber(15,fp);
        		}
        	}
        	for(y=0;y<NNN;y++) {
        		IDCT8(c+y*NNN,b+y*NNN);
        	}
        	tenchi(b,NNN);
        	for(y=0;y<8;y++) {
        		IDCT8(b+y*NNN,a+y*NNN);
        	}
        	for(y=0;y<NNN;y++) {
        		for(x=0;x<NNN;x++) {
                	tmp=(int)(a[x+y*NNN]/16.0);
                	if(tmp<0) tmp=0;
                	if(tmp>255) tmp=255;
                	col.r=tmp;
                	col.g=tmp;
                	col.b=tmp;
                	setPixel(img,lx*NNN+x,ly*NNN+y,&col);
        		}
        	}
        }
    }
}

double c14;
double s18;
double c18;
double s38;
double c38;
double s1h;
double c1h;
double s5h;
double c5h;
double s3h;
double c3h;
double s7h;
double c7h;

initConst()
{
    c14=cos(M_PI/4);
    s18=sin(M_PI/8);
    c18=cos(M_PI/8);
    s38=sin(3*M_PI/8);
    c38=cos(3*M_PI/8);
    s1h=sin(M_PI/16);
    c1h=cos(M_PI/16);
    s5h=sin(5*M_PI/16);
    c5h=cos( 5*M_PI/16);
    s3h=sin( 3*M_PI/16);
    c3h=cos( 3*M_PI/16);
    s7h=sin(7*M_PI/16);
    c7h=cos(7*M_PI/16);
}

int IDCT8( double *in, double *out)
{
	double t0, t1, t2, t3, t4, t5, t6, t7;
	double u0, u1, u2, u3, u4, u5, u6, u7;

	t4 =  in[1]*s1h - in[7]*s7h;
	t5 =  in[5]*s5h - in[3]*s3h;
	t6 =  in[5]*c5h + in[3]*c3h;
	t7 =  in[1]*c1h + in[7]*c7h;

	u0 =  in[0]*c14 + in[4]*c14;
	u1 =  in[0]*c14 - in[4]*c14;
	u2 =  in[2]*s18 - in[6]*s38;
	u3 =  in[2]*c18 + in[6]*c38;
	u4 =  t4 + t5;
	u5 =  t4 - t5;
	u6 = -t6 + t7;
	u7 =  t6 + t7;

	t0 =  u0 + u3;
	t1 =  u1 + u2;
	t2 =  u1 - u2;
	t3 =  u0 - u3;
	t4 =  u4;
	t5 = -u5 * c14 + u6 * c14;
	t6 =  u5 * c14 + u6 * c14;
	t7 =  u7;

	out[ 0 ] = t0 + t7;
	out[ 1 ] = t1 + t6;
	out[ 2 ] = t2 + t5;
	out[ 3 ] = t3 + t4;
	out[ 4 ] = t3 - t4;
	out[ 5 ] = t2 - t5;
	out[ 6 ] = t1 - t6;
	out[ 7 ] = t0 - t7;
}

int tenchi(double *mat,int n)
{
	int x,y;
	double tmp;

	for(y=0;y<n;y++) {
		for(x=0;x<n;x++) {
			if(x<y) {
				tmp=mat[x+y*n];
				mat[x+y*n]=mat[y+x*n];
				mat[y+x*n]=tmp;
			}
		}
	}
}
