#include "image.h"
#include <stdlib.h>
#include <math.h>

#define NNN 8
#define PAI 3.14159265

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	res=readBMPfile(av[1],&img);
	if(res<0) {
		printf("摜ǂ߂܂(%d)\n",res);
		return 8;
	}

	writePicture(av[2],img);
	disposeImage(img);
}

int writePicture(char *fname,ImageData *img)
{
	FILE *fpo;
	int x,y;
	int mx,my,dep;
	Pixel pix;

	mx=img->width;
	my=img->height;
	dep=8;

	if((fpo=fopen((char*)fname,"wb"))==NULL) return FALSE;
	
	outputHeader(fpo,mx,my,dep);
	encode(fpo,img);
	fclose(fpo);

}

int fputLong(long num,FILE *fp)
{
	fputc((num>>24) & 0xff,fp);
	fputc((num>>16) & 0xff,fp);
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

int fputShort(signed short num,FILE *fp)
{
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}


int outputHeader(FILE *fp,int mx,int my,int dep)
{
	int i;

	fputc('D',fp);
	fputc('C',fp);
	fputc('T',fp);
	fputc('1',fp);
	fputLong(mx,fp);
	fputLong(my,fp);
}

static int bits=0;
static int bdata=0;

int fputBitInit()
{
	bits=0;
	bdata=0;
}

// 1rbgo
int fputBit(int bit,FILE *fp)
{
	bdata=(bdata<<1)|bit;
	bits++;
	if(bits>=8) {
		fputc(bdata,fp);
		bits=0;
		bdata=0;
	}
}

// nrbgo
int putBits(FILE *fp,int data,int n)
{
    int i;

    for(i=n-1;i>=0;i--) {
        fputBit((data>>i)&1,fp);
    }
}

// ]rbgo
int flushBit(FILE *fp)
{
	int i;

	for(i=0;i<7;i++) {
		fputBit(0,fp);
	}
}

int fputNumber(int num,int bits,FILE *fp)
{
    if(num<0) {
        fputBit(1,fp);
        num= -num;
    }
    else {
        fputBit(0,fp);
    }
    putBits(fp,num,bits);
}

int fputCompNumber(int num,int bits,FILE *fp)
{
    if(num<0) {
        fputBit(1,fp);
        num= -num;
    }
    else {
        fputBit(0,fp);
    }
    num=num>>(16-bits);
    putBits(fp,num,bits-1);
}

int tenchi(double *mat,int n)
{
	int x,y;
	double tmp;

	for(y=0;y<n;y++) {
		for(x=0;x<n;x++) {
			if(x<y) {
				tmp=mat[x+y*n];
				mat[x+y*n]=mat[y+x*n];
				mat[y+x*n]=tmp;
			}
		}
	}
}

int encode(FILE *fp,ImageData *img)
{
    int x,y,u,v;
    int lx,ly,loopx,loopy;
    double r_re[NNN*NNN],b[NNN*NNN],c[NNN*NNN];
    int sum;
	Pixel col;
	int code_bits[8*8]=
	{
		16,14,12,10, 8, 6, 4, 4,
		14,12,10, 8, 6, 4, 4, 4,
		12,10, 8, 6, 4, 4, 4, 4,
		10, 8, 6, 4, 4, 4, 4, 4,
		 8, 6, 4, 4, 4, 4, 4, 4,
		 6, 4, 4, 4, 4, 4, 4, 4,
		 4, 4, 4, 4, 4, 4, 4, 4,
		 4, 4, 4, 4, 4, 4, 4, 4
	};
	int mx,my;

	mx=img->width;
	my=img->height;

    loopx=(mx+NNN-1)/NNN;
    loopy=(my+NNN-1)/NNN;
    fputBitInit();
    initConst();
    for(ly=0;ly<loopy;ly++) {
        for(lx=0;lx<loopx;lx++) {
        	// obt@쐬
        	for(y=0;y<NNN;y++) {
        		for(x=0;x<NNN;x++) {
        			getPixel(img,lx*NNN+x,ly*NNN+y,&col);
        			r_re[x+y*NNN]=(double)(col.r);
        		}
        	}

        	for(y=0;y<8;y++) {
        		DCT8(r_re+y*8,b+y*8);
        	}
        	tenchi(b,8);
        	for(y=0;y<8;y++) {
        		DCT8(b+y*8,c+y*8);
        	}

        	for(y=0;y<NNN;y++) {
        		for(x=0;x<NNN;x++) {
        		    fputCompNumber((int)(c[x+y*NNN]),code_bits[y*8+x],fp);
        		}
        	}
        }
    }
    flushBit(fp);
}

double c14;
double s18;
double c18;
double s38;
double c38;
double s1h;
double c1h;
double s5h;
double c5h;
double s3h;
double c3h;
double s7h;
double c7h;

initConst()
{
    c14=cos(  M_PI/4);
    s18=sin(  M_PI/8);
    c18=cos(  M_PI/8);
    s38=sin(3*M_PI/8);
    c38=cos(3*M_PI/8);
    s1h=sin(  M_PI/16);
    c1h=cos(  M_PI/16);
    s5h=sin(5*M_PI/16);
    c5h=cos(5*M_PI/16);
    s3h=sin(3*M_PI/16);
    c3h=cos(3*M_PI/16);
    s7h=sin(7*M_PI/16);
    c7h=cos(7*M_PI/16);
}

int DCT8( double *in, double *out)
{
	double tmp0,tmp1,tmp2,tmp3;
	double tmp4,tmp5,tmp6,tmp7;
	double u4, u5, u6, u7;
	
	tmp0 = in[0] + in[7];
	tmp1 = in[1] + in[6];
	tmp2 = in[2] + in[5];
	tmp3 = in[3] + in[4];
	tmp4 = in[3] - in[4];
	tmp5 = in[2] - in[5];
	tmp6 = in[1] - in[6];
	tmp7 = in[0] - in[7];
	
	out[ 0 ] =  (tmp0 + tmp3) * c14 + (tmp1 + tmp2) * c14;
	out[ 4 ] =  (tmp0 + tmp3) * c14 - (tmp1 + tmp2) * c14;
	out[ 2 ] =  (tmp1 - tmp2) * s18 + (tmp0 - tmp3) * c18;
	out[ 6 ] = -(tmp1 - tmp2) * s38 + (tmp0 - tmp3) * c38;
	
	u4 =  tmp4;
	u5 = -tmp5 * c14 + tmp6 * c14;
	u6 =  tmp5 * c14 + tmp6 * c14;
	u7 =  tmp7;
	
	tmp4 =  u4 + u5;
	tmp5 =  u4 - u5;
	tmp6 = -u6 + u7;
	tmp7 =  u6 + u7;
	
	out[ 1 ] =  tmp4 * s1h + tmp7 * c1h;
	out[ 5 ] =  tmp5 * s5h + tmp6 * c5h;
	out[ 3 ] = -tmp5 * s3h + tmp6 * c3h;
	out[ 7 ] = -tmp4 * s7h + tmp7 * c7h;
}
