#include "image.h"
#include <stdio.h>
#include <limits.h>
#include <math.h>

#define NNN 8
#define Nketa 3

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	getPicture(av[1],&img);
	writeBMPfile(av[2],img);
	//disposeImage(img);
}

int getPicture(char *file_name,ImageData **img)
{
	unsigned int sig_read = 0;
	int bit_depth, color_type, interlace_type;
	int i;
	unsigned char *tmprow;
	int mx2;
	int mx,my,mmx,dep,rdep;
	int mode;
	FILE *fp;

	fp=fopen(file_name,"rb");
	if(fp==NULL) {
		printf("File Open Error\n");
		return FALSE;
	}

	// 摜TCY̓ǂݏo
	getImgInfo(&mx,&my,&dep,fp);

	*img=createImage(mx,my,24);

	decode(fp,*img);

	fclose(fp);
	return 0;
}

int getLong(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,4,fp);
	return (buf[0]<<24) |(buf[1]<<16) | (buf[2]<<8) | buf[3];
}

int getShort(FILE *fp)
{
	unsigned char buf[10];

	readData(buf,2,fp);
	return (buf[0]<<8) | buf[1];
}

unsigned int getC(FILE *fp)
{
	unsigned char buf[4];

	readData(buf,1,fp);
	return (unsigned int)buf[0];
}

int readData(unsigned char *data,int len,FILE *fp)
{
   return fread(data,sizeof(char),len,fp);
}

// -------------------------------------------------------
static int bits=0;
static int bdata=0;

int fgetBitInit()
{
	bits=0;
	bdata=0;
}

// 1rbg
int fgetBit(FILE *fp)
{
	unsigned char bbuf;
	char buf[100];
	int val;

	if(bits==0) {
		readData(&bbuf,1,fp);
		bdata=bbuf;
	}
	val=(bdata>>7)&1;
	bdata=(bdata<<1) & 0xff;
	bits++;
	if(bits>=8) {
		bits=0;
		bdata=0;
	}
	return val;
}

int fgetNumber(int bits,FILE *fp)
{
    int i,res,sn;

    res=0;
    for(i=0;i<bits;i++) {
        res=res*2;
        res+=fgetBit(fp);
    }
    return res;
}

int getImgInfo(int *mx,int *my,int *dep,FILE *fp)
{
	int i;
	char buf[100],sbuf[256];

	readData(buf,4,fp);
	*mx=getLong(fp);
	*my=getLong(fp);
	*dep=getLong(fp);
}

short adm[NNN][NNN][NNN][NNN];

int scan[]={
     1, 8,16, 9, 2, 3,10,
    17,24,32,25,18,11, 4, 5,
    12,19,26,33,40,48,41,34,
    27,20,13, 6, 7,14,21,28,
    35,42,49,56,57,50,43,36,
    29,22,15,23,30,37,44,51,
    58,59,52,45,38,31,39,46,
    53,60,61,54,47,55,62,63
};

#define ZERORUN 100
#define NUM 1
#define EOB 101

int Qtable[]={
     16, 11, 10, 16, 24, 40, 51, 61,
     12, 12, 14, 19, 26, 58, 60, 55,
     14, 13, 16, 24, 40, 57, 69, 56,
     14, 17, 22, 29, 51, 87, 80, 62,
     18, 22, 37, 57, 68,109,103, 77,
     24, 35, 55, 64, 81,104,113, 92,
     49, 64, 78, 87,103,121,120,101,
     72, 92, 95, 98,112,100,103, 99
};

int decode(FILE *fp,ImageData *img)
{
    int x,y,u,v;
    int lx,ly,loopx,loopy;
    double c[NNN*NNN],b[NNN*NNN],a[NNN*NNN];
    int i,j;
    int ope,val;
    int *DCval;
    int tmp;
    int grp,jun;
    int datas;
    int bef,tmp2;
	Pixel col;
    int DChist[16*2],AChist[16*16*2];
	int mx,my;

	mx=img->width;
	my=img->height;

    loopx=(mx+NNN-1)/NNN;
    loopy=(my+NNN-1)/NNN;
	fgetBitInit();
	initConst();

    // pxe[uǂݍ
	for(i=0;i<16;i++)
	    DChist[i]=getLong(fp);
	for(i=0;i<16*16;i++)
	    AChist[i]=getLong(fp);

    datas=makeTree(DChist,16);
    DCval=malloc(sizeof(int)*loopx*loopy);
    for(i=0;i<loopx*loopy;i++) {
        grp=getValue(16,datas,fp);
        if(grp>0)
            jun=fgetNumber(grp,fp);
        else
            jun=0;
        DCval[i]=getOrg(grp,jun);
    }
    for(i=1;i<loopx*loopy;i++) {
        DCval[i]+=DCval[i-1];
    }
    datas=makeTree(AChist,256);
    for(ly=0;ly<loopy;ly++) {
        for(lx=0;lx<loopx;lx++) {
            c[0]=(double)(DCval[lx+ly*loopx]);
            i=0;
            while(i<63) {
                ope=getValue(256,datas,fp);
                if(ope>0 && ope<0xf0)
                    val=fgetNumber(ope%16,fp);
                else
                    val=0;
                if(ope==0) {
                    for(;i<63;i++) {
                        c[scan[i]]=(double)0;
                    }
                    break;
                }
                else if(ope<0x10) {
                    c[scan[i]]=(double)getOrg(ope,val);
                    i++;
                }
                else if(ope<0xf0){
                    for(j=0;j<ope/16;j++) {
                        c[scan[i]]=(double)0;
                        i++;
                    }
                    ope%=16;
                    c[scan[i]]=(double)getOrg(ope,val);
                    i++;
                }
                else {
                    ope&=0xf;
                    for(j=0;j<15+ope;j++) {
                        c[scan[i]]=(double)0;
                        i++;
                    }
                }
            }
            // ʎq
            for(i=0;i<64;i++) {
                //if(i%8==7) ;
                c[i]*=Qtable[i];
            }
        	for(y=0;y<NNN;y++) {
        		IDCT8(c+y*NNN,b+y*NNN);
        	}
        	tenchi(b,NNN);
        	for(y=0;y<8;y++) {
        		IDCT8(b+y*NNN,a+y*NNN);
        	}
        	for(y=0;y<NNN;y++) {
        		for(x=0;x<NNN;x++) {
                	tmp=(int)(a[x+y*NNN]/4.0);
                	if(tmp<0) tmp=0;
                	if(tmp>255) tmp=255;
                	col.r=tmp;
                	col.g=tmp;
                	col.b=tmp;
                	setPixel(img,lx*NNN+x,ly*NNN+y,&col);
        		}
        	}
        }
    }
    free(DCval);
}

int getOrg(int grp,int jun)
{
	int i,code;
	int mask,mask2;

	mask=(1<<(grp));
	mask2=mask/2;
	if(jun<mask2) {
	    return jun-mask+1;
	}
	else {
	    return jun;
	}
}

double c14;
double s18;
double c18;
double s38;
double c38;
double s1h;
double c1h;
double s5h;
double c5h;
double s3h;
double c3h;
double s7h;
double c7h;

initConst()
{
    c14=cos(M_PI/4);
    s18=sin(M_PI/8);
    c18=cos(M_PI/8);
    s38=sin(3*M_PI/8);
    c38=cos(3*M_PI/8);
    s1h=sin(M_PI/16);
    c1h=cos(M_PI/16);
    s5h=sin(5*M_PI/16);
    c5h=cos( 5*M_PI/16);
    s3h=sin( 3*M_PI/16);
    c3h=cos( 3*M_PI/16);
    s7h=sin(7*M_PI/16);
    c7h=cos(7*M_PI/16);
}

int IDCT8( double *in, double *out)
{
	double t0, t1, t2, t3, t4, t5, t6, t7;
	double u0, u1, u2, u3, u4, u5, u6, u7;

	t4 =  in[1]*s1h - in[7]*s7h;
	t5 =  in[5]*s5h - in[3]*s3h;
	t6 =  in[5]*c5h + in[3]*c3h;
	t7 =  in[1]*c1h + in[7]*c7h;

	u0 =  in[0]*c14 + in[4]*c14;
	u1 =  in[0]*c14 - in[4]*c14;
	u2 =  in[2]*s18 - in[6]*s38;
	u3 =  in[2]*c18 + in[6]*c38;
	u4 =  t4 + t5;
	u5 =  t4 - t5;
	u6 = -t6 + t7;
	u7 =  t6 + t7;

	t0 =  u0 + u3;
	t1 =  u1 + u2;
	t2 =  u1 - u2;
	t3 =  u0 - u3;
	t4 =  u4;
	t5 = -u5 * c14 + u6 * c14;
	t6 =  u5 * c14 + u6 * c14;
	t7 =  u7;

	out[ 0 ] = t0 + t7;
	out[ 1 ] = t1 + t6;
	out[ 2 ] = t2 + t5;
	out[ 3 ] = t3 + t4;
	out[ 4 ] = t3 - t4;
	out[ 5 ] = t2 - t5;
	out[ 6 ] = t1 - t6;
	out[ 7 ] = t0 - t7;
}

int tenchi(double *mat,int n)
{
	int x,y;
	double tmp;

	for(y=0;y<n;y++) {
		for(x=0;x<n;x++) {
			if(x<y) {
				tmp=mat[x+y*n];
				mat[x+y*n]=mat[y+x*n];
				mat[y+x*n]=tmp;
			}
		}
	}
}

#define N 256
#define NODATA 2100000000

// nt}
int l_node[2*N],r_node[2*N];
int parent[2*N];

// ŏpx̂Q߂
int getMin2(int *hist,int hm,int *d1,int *d2)
{
	int i;
	int min;

	min=NODATA-1;
	*d1= *d2= -100;
	for(i=0;i<hm;i++) {
		if(hist[i]<min) {
			*d1=i;
			min=hist[i];
		}
	}
	min=NODATA-1;
	for(i=0;i<hm;i++) {
		if(i!=(*d1) && hist[i]<min) {
			*d2=i;
			min=hist[i];
		}
	}
}

int makeTree(int *hist,int n)
{
	int hm_data;
	int d1,d2,i;

	hm_data=n;

	// 
	for(i=0;i<2+N;i++) {
		l_node[i]=r_node[i]=parent[i]=0;
	}

	while(1) {
		// ŏpx̂Q߂
		getMin2(hist,hm_data,&d1,&d2);
		// ŏlƂȂ̂ȂΏI
		if(d1<0 || d2<0) break;
		l_node[hm_data]=d1;
		r_node[hm_data]=d2;
		parent[d1]=hm_data;
		parent[d2]= -hm_data;
		hist[hm_data]=hist[d1]+hist[d2];
		hist[d1]=NODATA;
		hist[d2]=NODATA;
		hm_data++;
	}
	return hm_data;
}

int getValue(int n,int datas,FILE *fp)
{
	int rt,bit;

	rt=datas-1;
	while(rt>=n) {
		bit=fgetBit(fp);
		if(bit==0) {
			rt=l_node[rt];
		}
		else {
			rt=r_node[rt];
		}
	}
	return rt;
}
