#include "image.h"
#include <stdlib.h>
#include <stdio.h>
#include <math.h>


#define PAI 3.14159265
#define NNN 8

main(int ac,char *av[])
{
	ImageData *img;
	int res;

	if(ac<3) {
		printf("p[^܂\n");
		return 8;
	}

	// t@C摜f[^̓ǂݍ
	res=readBMPfile(av[1],&img);
	if(res<0) {
		printf("摜ǂ߂܂(%d)\n",res);
		return 8;
	}

	writePicture(av[2],img);
	disposeImage(img);
}

int writePicture(char *fname,ImageData *img)
{
	FILE *fpo;
	int x,y;
	int mx,my,dep;
	Pixel pix;

	mx=img->width;
	my=img->height;
	dep=8;

	if((fpo=fopen((char*)fname,"wb"))==NULL) return FALSE;
	
	outputHeader(fpo,mx,my,dep);
	encode(fpo,img);
	fclose(fpo);

}

int fputLong(long num,FILE *fp)
{
	fputc((num>>24) & 0xff,fp);
	fputc((num>>16) & 0xff,fp);
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}

int fputShort(signed short num,FILE *fp)
{
	fputc((num>>8)  & 0xff,fp);
	fputc((num)     & 0xff,fp);
}


int outputHeader(FILE *fp,int mx,int my,int dep)
{
	int i;

	fputc('D',fp);
	fputc('C',fp);
	fputc('T',fp);
	fputc('3',fp);
	fputLong(mx,fp);
	fputLong(my,fp);
	fputLong(dep,fp);
}

static int bits=0;
static int bdata=0;

int fputBitInit()
{
	bits=0;
	bdata=0;
}

// 1rbgo
int fputBit(int bit,FILE *fp)
{
	bdata=(bdata<<1)|bit;
	bits++;
	if(bits>=8) {
		fputc(bdata,fp);
		bits=0;
		bdata=0;
	}
}

// nrbgo
int putBits(FILE *fp,int data,int n)
{
    int i;

    for(i=n-1;i>=0;i--) {
        fputBit((data>>i)&1,fp);
    }
}

// ]rbgo
int flushBit(FILE *fp)
{
	int i;

	for(i=0;i<7;i++) {
		fputBit(0,fp);
	}
}

int fputNumber(int num,int bits,FILE *fp)
{
    if(num<0) {
        fputBit(1,fp);
        num= -num;
    }
    else {
        fputBit(0,fp);
    }
    putBits(fp,num,bits);
}

int tenchi(double *mat,int n)
{
	int x,y;
	double tmp;

	for(y=0;y<n;y++) {
		for(x=0;x<n;x++) {
			if(x<y) {
				tmp=mat[x+y*n];
				mat[x+y*n]=mat[y+x*n];
				mat[y+x*n]=tmp;
			}
		}
	}
}

int* get2Dcode(int *p,int *code);

int Qtable[]={
     16, 11, 10, 16, 24, 40, 51, 61,
     12, 12, 14, 19, 26, 58, 60, 55,
     14, 13, 16, 24, 40, 57, 69, 56,
     14, 17, 22, 29, 51, 87, 80, 62,
     18, 22, 37, 57, 68,109,103, 77,
     24, 35, 55, 64, 81,104,113, 92,
     49, 64, 78, 87,103,121,120,101,
     72, 92, 95, 98,112,100,103, 99
};

int encode(FILE *fp,ImageData *img)
{
    int x,y,u,v,i;
    int lx,ly,loopx,loopy;
    double r_re[NNN*NNN],b[NNN*NNN],c[NNN*NNN];
    int dct_res[NNN*NNN];
    int DChist[16*2],AChist[16*16*2];
    int *DCval,*dc_p;
    int *scanline,sn,*np,sres;
    int *p;
    int grp,jun;
    int sum;
    int datas;
    int bef,tmp;
    int code;
	Pixel col;
	int mx,my;

	mx=img->width;
	my=img->height;

    loopx=(mx+NNN-1)/NNN;
    loopy=(my+NNN-1)/NNN;

    scanline=malloc(sizeof(int)*loopx*NNN*loopy*NNN*2);
    DCval=malloc(sizeof(int)*loopx*loopy);

    fputBitInit();
    initConst();

    np=scanline;
    dc_p=DCval;
    for(ly=0;ly<loopy;ly++) {
        for(lx=0;lx<loopx;lx++) {
        	// obt@쐬
        	for(y=0;y<NNN;y++) {
        		for(x=0;x<NNN;x++) {
        			getPixel(img,lx*NNN+x,ly*NNN+y,&col);
        			r_re[x+y*NNN]=(double)(col.r);
        		}
        	}

            /* 2DCT */
        	for(y=0;y<8;y++) {
        		DCT8(r_re+y*8,b+y*8);
        	}
        	tenchi(b,8);
        	for(y=0;y<8;y++) {
        		DCT8(b+y*8,c+y*8);
        	}
        	for(i=0;i<NNN*NNN;i++) {
        	    dct_res[i]=c[i]*2/NNN;
        	    // ʎq
        	    dct_res[i]/=Qtable[i];
            }

            /* DC̒o */
            *dc_p=dct_res[0];
            dc_p++;
            /* AC̃OX */
            sres=scanDCT(dct_res,np);

        	np+=sres;
        }
    }
    // ̏o
    // l߂
    bef=(*DCval);
    for(p=DCval+1;p<dc_p;p++) {
        tmp=(*p)-bef;
        bef=(*p);
        (*p)=tmp;
    }
    // pxe[u
    for(i=0;i<16;i++) DChist[i]=0;
    for(p=DCval;p<dc_p;p++) {
		getCode(*p,&grp,&jun);
		DChist[grp]++;
    }
    for(i=0;i<16*16;i++) AChist[i]=0;
    for(p=scanline;p<np;) {
        p=get2Dcode(p,&code);
        AChist[code]++;
    }
    for(i=0;i<16;i++)
        fputLong(DChist[i],fp);
    for(i=0;i<16*16;i++)
        fputLong(AChist[i],fp);
    // nt}iؐj
    datas=makeTree(DChist,16);
    // nt}iój
    for(p=DCval;p<dc_p;p++) {
		getCode(*p,&grp,&jun);
        outputEncode(grp,datas,fp);
        if(grp>0)
            putBits(fp,jun,grp);
    }
    // 𗬐̏o
    datas=makeTree(AChist,256);
    for(p=scanline;p<np;) {
        p=get2Dcode(p,&code);
        outputEncode(code,datas,fp);
        if(code>0 && code<0xf0) {
            putBits(fp,*(p-1),code&0xf);
        }
    }
    free(scanline);
    free(DCval);
    flushBit(fp);
}

int scan[]={
     1, 8,16, 9, 2, 3,10,
    17,24,32,25,18,11, 4, 5,
    12,19,26,33,40,48,41,34,
    27,20,13, 6, 7,14,21,28,
    35,42,49,56,57,50,43,36,
    29,22,15,23,30,37,44,51,
    58,59,52,45,38,31,39,46,
    53,60,61,54,47,55,62,63
};

#define ZERORUN 100
#define NUM 1
#define EOB 101

int scanDCT(int *in,int *out)
{
	int i,n;
	int c;
	int run=0;
	int grp,jun;

	n=0;
	for(i=0;i<63;i++) {
		c=in[scan[i]];
		if(c!=0) {
			if(run>0) {
				out[n++]=ZERORUN;
				out[n++]=run;
			}
			getCode(c,&grp,&jun);
			out[n++]=grp;
			out[n++]=jun;
			run=0;
		}
		else {
			run++;
		}
	}
	if(run>0) {
			out[n++]=EOB;
			out[n++]=0;
	}
	return n;
}

int* get2Dcode(int *p,int *code)
{
    int run;

    switch(*p){
    case EOB:
        *code= 0x00;
        return p+2;
    case ZERORUN:
        run= *(p+1);
        if(run>=15) {
            *code= 0xf0|(run%16);
            return p+2;
        }
        else {
            *code=(run*16)|(*(p+2));
            return p+4;
        }
    default:
        *code=(*p);
        return p+2;
    }
    return NULL;
}


double c14;
double s18;
double c18;
double s38;
double c38;
double s1h;
double c1h;
double s5h;
double c5h;
double s3h;
double c3h;
double s7h;
double c7h;

initConst()
{
    c14=cos(  M_PI/4);
    s18=sin(  M_PI/8);
    c18=cos(  M_PI/8);
    s38=sin(3*M_PI/8);
    c38=cos(3*M_PI/8);
    s1h=sin(  M_PI/16);
    c1h=cos(  M_PI/16);
    s5h=sin(5*M_PI/16);
    c5h=cos(5*M_PI/16);
    s3h=sin(3*M_PI/16);
    c3h=cos(3*M_PI/16);
    s7h=sin(7*M_PI/16);
    c7h=cos(7*M_PI/16);
}

int DCT8( double *in, double *out)
{
	double tmp0,tmp1,tmp2,tmp3;
	double tmp4,tmp5,tmp6,tmp7;
	double u4, u5, u6, u7;

	tmp0 = in[0] + in[7];
	tmp1 = in[1] + in[6];
	tmp2 = in[2] + in[5];
	tmp3 = in[3] + in[4];
	tmp4 = in[3] - in[4];
	tmp5 = in[2] - in[5];
	tmp6 = in[1] - in[6];
	tmp7 = in[0] - in[7];

	out[ 0 ] =  (tmp0 + tmp3) * c14 + (tmp1 + tmp2) * c14;
	out[ 4 ] =  (tmp0 + tmp3) * c14 - (tmp1 + tmp2) * c14;
	out[ 2 ] =  (tmp1 - tmp2) * s18 + (tmp0 - tmp3) * c18;
	out[ 6 ] = -(tmp1 - tmp2) * s38 + (tmp0 - tmp3) * c38;

	u4 =  tmp4;
	u5 = -tmp5 * c14 + tmp6 * c14;
	u6 =  tmp5 * c14 + tmp6 * c14;
	u7 =  tmp7;

	tmp4 =  u4 + u5;
	tmp5 =  u4 - u5;
	tmp6 = -u6 + u7;
	tmp7 =  u6 + u7;

	out[ 1 ] =  tmp4 * s1h + tmp7 * c1h;
	out[ 5 ] =  tmp5 * s5h + tmp6 * c5h;
	out[ 3 ] = -tmp5 * s3h + tmp6 * c3h;
	out[ 7 ] = -tmp4 * s7h + tmp7 * c7h;
}

int getGroup(int n)
{
	if(n==0) return 0;
	if(n>=    -1 && n<=    1) return 1;
	if(n>=    -3 && n<=    3) return 2;
	if(n>=    -7 && n<=    7) return 3;
	if(n>=   -15 && n<=   15) return 4;
	if(n>=   -31 && n<=   31) return 5;
	if(n>=   -63 && n<=   63) return 6;
	if(n>=  -127 && n<=  127) return 7;
	if(n>=  -255 && n<=  255) return 8;
	if(n>=  -511 && n<=  511) return 9;
	if(n>= -1023 && n<= 1023) return 10;
	if(n>= -2047 && n<= 2047) return 11;
	if(n>= -4095 && n<= 4095) return 12;
	if(n>= -8191 && n<= 8191) return 13;
	if(n>=-16383 && n<=16383) return 14;
	if(n>=-32767 && n<=32767) return 15;

}

int getCode(int c,int *grp,int *jun)
{
	int i,code;
	int mask;

	*grp=getGroup(c);
	if(c<0) code=c+1;
	else code=c;
	mask=(1<<(*grp))-1;
	*jun=c&mask;
	if(c<0) (*jun)--;
}

#define N 256
#define NODATA 2100000000

// nt}
int l_node[2*N],r_node[2*N];
int parent[2*N];

// ŏpx̂Q߂
int getMin2(int *hist,int hm,int *d1,int *d2)
{
	int i;
	int min;

	min=NODATA-1;
	*d1= *d2= -100;
	for(i=0;i<hm;i++) {
		if(hist[i]<min) {
			*d1=i;
			min=hist[i];
		}
	}
	min=NODATA-1;
	for(i=0;i<hm;i++) {
		if(i!=(*d1) && hist[i]<min) {
			*d2=i;
			min=hist[i];
		}
	}
}

int makeTree(int *hist,int n)
{
	int hm_data;
	int d1,d2,i;

	hm_data=n;

	// 
	for(i=0;i<2+N;i++) {
		l_node[i]=r_node[i]=parent[i]=0;
	}

	while(1) {
		// ŏpx̂Q߂
		getMin2(hist,hm_data,&d1,&d2);
		// ŏlƂȂ̂ȂΏI
		if(d1<0 || d2<0) break;
		l_node[hm_data]=d1;
		r_node[hm_data]=d2;
		parent[d1]=hm_data;
		parent[d2]= -hm_data;
		hist[hm_data]=hist[d1]+hist[d2];
		hist[d1]=NODATA;
		hist[d2]=NODATA;
		hm_data++;
	}
	return hm_data;
}

// nt}o
int outputEncode(int val,int end,FILE *fp)
{
	int c;
	int code[100];
	int now,i;
	int s1,a1;
	char buf[100];

	c=0;
	now=val;
	while(1) {
		s1=sgni(parent[now]);
		a1=absi(parent[now]);
		if(s1<0) code[c++]=1;
		else code[c++]=0;
		if(a1==end-1) break;
		now=a1;
	}
	for(i=c-1;i>=0;i--) {
		fputBit(code[i],fp);
	}
}

int sgni(int x)
{
    if(x<0)
        return -1;
    if(x>0)
        return 1;
    return 0;
}

int absi(int x)
{
    if(x<0)
        return -x;
    return x;
}
